<template>
    <div class="timer-app ">
        <div class="app-header">
            <div class="top-app">
                <router-link to="/timer">
                    <span class="icon-close"></span>
                </router-link>
                <h1 class="title bounce animated">Task submit</h1>
                <span></span>
            </div>
            <div class="top-container">
                <div class="duties">
                    <h3> {{ project }} </h3>
                    <h3> {{ key }} - {{ formatText(description,70) }}</h3>
                </div>
                <div class="timer">
                    <h1> {{ formatNumbers(hours) }}:{{ formatNumbers(minutes) }}</h1>
                    <div class="status-wrapper">

                        <p class="status">{{ currentStatus }}</p>

                    </div>
                </div>
            </div>
            <div v-bind:class="[error.show? 'active-message': '' ,'info-messages']">
                <p>{{ error.message  }}</p>
            </div>
        </div>
        <!--tasks-->
        <div class="app-tasks">
           <div class="task-grid">
                <textarea v-model="comment"  name="" placeholder="comments" id="comments"></textarea>
                <v-select :value="statusSelected" :on-change="statusChange"  class="projets" :style="{margin: '5px 0', width: '100%'}" placeholder="Change to status..." :options="statuses"></v-select>
                <input v-model="setToZero" type="checkbox" id="zero"/>
                <label class="option" for="zero">Set remaining estimate to zero</label>
                <input v-model="removeAfter" type="checkbox" id="pause"/>
                <label class="option" for="pause">Remove this task after submit</label>
               
            </div>
        </div>

        <div class="app-footer">
            <span class="entry"></span>
            <label v-on:click="submitTime"  class="time-elapsed">send</label>
        </div>
    </div>
</template>

<script>
    const {ipcRenderer} = window.require('electron')
    import vSelect from "vue-select"
    export default {
      components: {vSelect},
      name: 'timer-page',
      data: function () {
        return {
          isBusy: false,
          removeAfter: false,
          setToZero: false,
          comment: '',
          error: {show: false, message: ''},
          statuses:[],
          currentStatus: '',
          statusSelected: null
        }
      },
      computed: {
        key () {
          return this.$store.state.counters.timer.key
        },
        description () {
          return this.$store.state.counters.timer.description
        },
        minutes () {
          return this.$store.state.counters.timer.minutes
        },
        hours () {
          return this.$store.state.counters.timer.hours
        },
        project () {
          return this.$store.state.counters.timer.project
        }
      },
      methods: {
        listFormat: function(list){
             return list.map(function(obj){   return  {'label': obj.name,'value': obj.id}; });
           
        },
        statusChange:function (val) {
          this.statusSelected = val
        },
        submitTime () {
          let record = {
            minutes: this.minutes,
            hours: this.hours,
            key: this.key,
            comment: this.comment,
            remaining: this.setToZero,
            status: this.statusSelected
          }
          if(!this.isBusy){
            this.isBusy = true;
            ipcRenderer.send('send-time', record)
          }
        },
        formatNumbers: function (number) {
          return ('0' + number).slice(-2)
        },
        formatText: function (text,cutAt){
              return text.substr(0,cutAt-1)+(text.length>cutAt?'...':'');
        },
      },
      activated: function(){
          this.statusSelected = null
          ipcRenderer.send('get-status', this.key)
      },
      created: function () {
     

        ipcRenderer.on('return-status', (event, arg) => {
        
            arg.statuses.forEach((item, index)=>{
                if (item.name === arg.status.name){
                    arg.statuses.splice(index, 1);
                }
            });

            let items = this.listFormat(arg.statuses)
            this.currentStatus = arg.status.name
            this.statuses = items
        })
        ipcRenderer.on('success-submit', (event, arg) => {
            let self = this
            self.error.message = 'Task submitted successfully';
            self.error.show = true
            setTimeout(function () {
                if (self.error.show === true) { self.error.show = false }
            }, 1000)
            setTimeout(function () {
                self.comment = ''
                self.setToZero = false
                self.$store.commit('CHANGE_STATUS', {status:true,remove:self.removeAfter})
                self.isBusy = false
                self.removeAfter = false
                self.statusSelected = null
                self.$router.push('timer')
            },1500)
        })
        ipcRenderer.on('failed-submit', (event, arg) => {
          // show message to end-user
          let self = this

          switch (arg.status){
          case 401:
            self.error.show = true
            self.error.message = 'Unauthorized access'
            break
          default:
            if(arg.data.hasOwnProperty('errorMessages')){
                self.error.message = arg.data.errorMessages[0];
            }else{
                self.error.message = 'Failed to connect with JIRA';
            }
            self.error.show = true
          }
          setTimeout(function () {
            if (self.error.show === true) { self.error.show = false }
            self.isBusy = false
          }, 2000)
        })
      }

    }

</script>


<style scoped lang="scss">
    @import url('https://fonts.googleapis.com/css?family=Roboto');

    //Imports
    $red-color: #ef5f59;
    $roboto: 'Roboto', sans-serif;


    .active-message{
        bottom:0 !important;
        transition: linear .5s;
    }



    textarea:focus, input:focus{
        outline: none;
    }
    .text{
        font-family: $roboto;
        font-size: 16px;
        color:#888;
    }
    .regular{
        font-family: $roboto;
        font-size: 14px;
        color:#888;
        margin:0;
    }
    .small{
        font-family: $roboto;
        font-size: 12px;
        color:#888;
        margin:0;
    }
    .timer-app {
        width: 100%;
        height: 100vh;
        background: white;
        color: white;
        overflow-y: hidden;
    }
    .app-header{
        height:200px;
        position: relative;
        background: $red-color;
        overflow: hidden;
        .top-app{
            width: 100%;
            height: 50px;
            line-height: 50px;
            text-align: center;
            box-shadow: 0 2px 5px -1px rgba(80, 79, 79, 0.75);
            position:relative;
            display: flex;
            justify-content: space-between;
            align-items: center;
            h1.title{
                font-family: $roboto;
                font-size: 18px;
                margin: 0;
                font-weight: 500;
            }
            span{
                font-size: 22px;
                color:#FFF;
                width: 45px;
                text-align: center;
                display: inline-block;
                &:hover{
                    color:#FEE;
                    cursor: pointer;
                    transition:all .3s;
                }

            }
        }
    }

    .top-container{
        width:100%;
        display:flex;
        justify-content:center;
        align-items:center;
        min-height:130px;

        .duties{
            width: 50%;
            h3{
                font-family: $roboto;
                font-size: 20px;
                text-align: center;
                margin: 0;
                line-height: 30px;
            }
        }
        .timer{
            width: 50%;
            h1{
                font-family: $roboto;
                font-size: 50px;
                margin: 0;
                text-align:center;
            }
            .status-wrapper{
                text-align:center;
                padding: 0 2px;
                p{
                   margin: 0; 
                   font-size: 12px;
                }

            }

        }
    }

    .info-messages{
        width: 100%;
        height: 25px;
        position: absolute;
        bottom:-26px;
        background: lighten(#eee,5%);
        border-bottom: 1px solid #eee;
        text-align: center;
        transition:all .5s;
        p{
            line-height: 25px;
            @extend .regular;
        }
    }


    .app-tasks{
        min-height: 150px;
        width:100%;
        height: 210px;
        background: white;
        padding: .5em 0;
        .task-grid{
            display: flex;
            flex-direction: column;
            width: 90%;
            height: 250px;
            background: white;
            margin: 2px auto;
            color: #888;
            .option{
                margin: 5px 0;
            }
            #comments{
                border-radius: 5px;
                width: 100%;
                height: 70%;
                font-family: $roboto;
                font-size: 14px;
                text-indent: 5px;
            }
        }
    }

    .app-footer{
        width: 100%;
        height: 50px;
        background: lighten(#eee,5%);
        position: fixed;
        bottom: 0;
        display: flex;
        align-items: center;
        color: black;
        justify-content: space-between;
        font-size: 14px;
        line-height: 50px;
        .entry{
            width: 70px;
            height: 35px;
            @extend .text;
            display: flex;
            align-items: center;
            justify-content: center;
            transition:all .3s;
            &:hover{
                color:lighten(#888,10%);
                cursor: pointer;
                transition:all .3s;
            }


            &::before{
                font-family: "timer";
                font-size: 18px;
                color:#888;
                display: inline-block;

                position: relative;
                top: 2px;
                left: -1px;
            }

        }
        .time-elapsed{
            cursor: pointer;
            @extend .text;
            min-width: 100px;
            text-align: center;
        }
    }
    /*ESTILOS CHECKBOX (NO TOCAR)*/
    [type="checkbox"]:not(:checked),
    [type="checkbox"]:checked {
        position: absolute;
        left: -9999px;
    }
    [type="checkbox"]:not(:checked) + label,
    [type="checkbox"]:checked + label {
        position: relative;
        padding-left: 1.95em;
        cursor: pointer;
        font-family: $roboto;
        font-size: 15px;

    }

    /* checkbox aspect */
    [type="checkbox"]:not(:checked) + label:before,
    [type="checkbox"]:checked + label:before {
        content: '';
        position: absolute;
        left: 0; top: 0;
        width: 1.25em; height: 1.25em;
        border: 2px solid #ccc;
        background: #fff;
        border-radius: 4px;
        box-shadow: inset 0 1px 3px rgba(0,0,0,.1);
    }
    /* checked mark aspect */
    [type="checkbox"]:not(:checked) + label:after,
    [type="checkbox"]:checked + label:after {
        content: '✔';
        position: absolute;
        top: .1em; left: .3em;
        font-size: 1.3em;
        line-height: 0.8;
        color: #ec4f33;
        transition: all .2s;
    }
    /* checked mark aspect changes */
    [type="checkbox"]:not(:checked) + label:after {
        opacity: 0;
        transform: scale(0);
    }
    [type="checkbox"]:checked + label:after {
        opacity: 1;
        transform: scale(1);
    }
</style>
